package com.alterdekim.game.entity;

import com.alterdekim.flash.decompiler.mapper.FlashClass;
import com.alterdekim.flash.decompiler.mapper.FlashField;
import com.alterdekim.flash.decompiler.mapper.FlashValue;
import com.alterdekim.flash.decompiler.mapper.FlashValueType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.*;

@ToString
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="missions")
@FlashClass(name = "mi")
public class Mission {
    @Id
    @FlashValue(type = FlashValueType.Id)
    private Long id;

    @Column(nullable = false)
    @FlashField(name = "MRId")
    private Integer mediaResourceId;

    @Column(nullable = false)
    @FlashField(name = "Type")
    private Integer type;

    @Column(nullable = false)
    @FlashField(name = "IsActive")
    private Boolean isActive;

    @Column(nullable = false)
    @FlashField(name = "CheckRole")
    private Boolean checkRole;
}
